/***************************************************************************
                          inputint.cpp  -  description
                             -------------------
    begin                : Sun Oct 17 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "inputint.h"

inputInt::inputInt(int curVal, int lowVal, int highVal, char *title, QWidget *parent, const char *name) : QDialog(parent,name,true){
	QString aux;
	initDialog();

// Conecta tudo
	connect( okButton, SIGNAL(pressed()), this, SLOT(accept()) );
	connect( cancelButton, SIGNAL(pressed()), this, SLOT(reject()) );
	connect( defaultBox, SIGNAL(pressed()), this, SLOT(defaultPressed()) );
	connect( intSlider, SIGNAL(valueChanged(int)), lcdNun, SLOT(display(int)) );

	intSlider->setRange( lowVal, highVal );	
	aux = title;
	aux.replace( QRegExp("&") , "" );
	aux.replace( QRegExp("\\.") , "" );
	setCaption( aux );


	if (curVal >= lowVal && curVal <= highVal && curVal != -1) {
		intSlider->setValue( curVal );
		defaultBox->setChecked( false );
		intSlider->setEnabled( TRUE );
		lcdNun->setEnabled( TRUE );
		intSlider->setPalette( kapp->backgroundColor );
		lcdNun->setPalette( kapp->backgroundColor );
	}
	else {
		defaultBox->setChecked( true );
		intSlider->setEnabled( FALSE );
		lcdNun->setEnabled( FALSE );
		intSlider->setPalette( kapp->inactiveTextColor );
		lcdNun->setPalette( kapp->inactiveTextColor );
	}
}
		

inputInt::~inputInt(){
}

void inputInt::defaultPressed(){
	if (defaultBox->isChecked() == TRUE) {
		intSlider->setEnabled( TRUE );
		lcdNun->setEnabled( TRUE );
		intSlider->setPalette( kapp->backgroundColor );
		lcdNun->setPalette( kapp->backgroundColor );
		lcdNun->display( intSlider->value() );
	}
	else {
		intSlider->setEnabled( FALSE );
		lcdNun->setEnabled( FALSE );
		intSlider->setPalette( kapp->inactiveTextColor );
		lcdNun->setPalette( kapp->inactiveTextColor );
		lcdNun->display(0);
	}
}

/** Retorna o valor selecionado
0 -> Default */
int inputInt::intValue(){
	if (defaultBox->isChecked() != true)
		return intSlider->value();
	else
		return -1;
}





























