/***************************************************************************
                          ksnes9x.cpp  -  description
                             -------------------
    begin                : Sun Oct 10 14:14:06 EST 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "ksnes9x.h"



QString PATH;
QString FILTER;
QString SNAP_FILTER;
QString SNAP_PATH;
QString SNES9X;
bool QUICK_SNAP;
bool QUICK_PROF;

KSnes9x::KSnes9x(QWidget*parent,const char* name){

	// Get configureation
	config=kapp->getConfig();

	// Create the snapshot dir
	snapDir = new KSnes9xSnapshotDir();
	
	// Arruma o tamanho
	setMinimumSize(440, 400);

	// Incicializa o config
	cfg = new KSnes9xConfig();

	// Inicializa os profiles
	initProfiles();

  // call inits to invoke all other construction parts
	initProfileMenu();
  initMenuBar();
  initKeyAccel();
	initStatusBar();

	// inicializa os valores da MenuBar
	initMenuBarValues();

	// Desligar o joystick e os cheats
	disableCommand( ID_JOYSTICK_JOYCONF );

	// Init the view
	view = new KSnes9xView(this);
	setCustomValues();
	setView(view);
	view->updateProfileMenu(profiles);

	// Conecta o botao
	connect( view->play, SIGNAL(clicked()), this, SLOT(goForIt()) );
	// Conecta a mudanca de diretorios
	connect( view->dirView, SIGNAL(dirChanged(const char *)), this, SLOT(slotStatusDir(const char *)) );
	// Conecta o double-click
	connect( view->dirView, SIGNAL(goPlay()), this, SLOT(goForIt()) );
	// Conecta a selecao
	connect( view->dirView, SIGNAL(fileClicked(const char *)), this, SLOT(updateFileInfo(const char *)) );
	// Conecta o SnapMenu
	connect( snapDir, SIGNAL(newMatch( QStrList * , int)), view, SLOT(updateSnapMenu( QStrList *, int)) );
	// Conecta o SnapMenu->select
	connect( view->snapshot_list, SIGNAL(activated(const char *)), this, SLOT(loadSnapshot(const char *)) );
	// Conecta o ProfileMenu->select
	connect( view->profile_list, SIGNAL(activated(int )), this, SLOT(loadProfile(int )) );
	connect( view->profile_list, SIGNAL(activated(const char *)), this, SLOT(saveRomProfile(const char *)) );
}


KSnes9x::~KSnes9x(){
}

/** Arruma os valores do cfg */
void KSnes9x::setCfgValues(int index){

	QStrList bOptions, iOptions;
	bool aux;
	int a, b, c, bOpt, iOpt;
	QString aux2;

	bOpt = cfg->boolOptions();
	bOpt += 1000;
	iOpt = cfg->intOptions();
	iOpt += 1100;

	if (index > 0)
		aux2.setNum(index);
	else
		aux2="";



	config->setGroup("Command Line Options");
	a = config->readListEntry("Boolean_options"+aux2, bOptions);
	b = config->readListEntry("Integer_options"+aux2, iOptions);
	if (a <= 0 || b <= 0) {
		debug("A: %d e B: %d", a, b);
		resetConfig();
		return;
	}
	for (a = 1000; a < bOpt; a++) {
			if( strnicmp(bOptions.at(a - 1000), "true", 4) == 0 )
				aux = true;
			else
				aux = false;
			cfg->setValue(a, aux);
	}
	for (b = 1100; b < iOpt; b++) {
			aux2 = iOptions.at(b - 1100);
			c = aux2.toInt();
			cfg->setValue(b, c);
	}

	if (index > 0)
		aux2.setNum(index);
	else
		aux2="";
	cfg->setValue(ID_JOYSTICK_MISC, config->readEntry("Custom_option"+aux2) );

}

/** Inicializa os valores da MenuBar */
void KSnes9x::initMenuBarValues(){
	int bOpt, a;
	bOpt = cfg->boolOptions();
	bOpt += 1000;
	for (a = 1000; a < bOpt; a++) {
		menuBar()->setItemChecked( a, cfg->boolValue( a ) );
	}
}

/** Bool option checked in the menubar */
void KSnes9x::slotBoolChecked(int _id){
	cfg->setValue( _id, !cfg->boolValue(_id) );
	menuBar()->setItemChecked( _id, cfg->boolValue( _id ) );
}

/** Roda o emulador */
void KSnes9x::goForIt(){
	if (!view->dirView->ok())
		return;
	QString optMsg;
	optMsg = "";
	optMsg += cfg->optString();
	optMsg += "\"";
	optMsg += view->dirView->fileName();		
	optMsg += "\"";
	debug( optMsg );
	p.clearArguments();
  p << SNES9X;
  p << optMsg;
	p.start();
}

/** Chama a inputint */
void KSnes9x::slotIntChecked( int id ){
	int a;
	inputInt m( cfg->intValue(id), cfg->getRange(id).min, cfg->getRange(id).max, (char *)menuBar()->text(id), this);
	if (m.exec()) {
		a = m.intValue();
		if (a >= 0)
			cfg->setValue( id, a);
		else if (a < 0)
			cfg->setDefault( id );
	}
}

/** Salva as opes */
void KSnes9x::saveOptions(){
	/* Pega as opcoes */

	// Opcoes booleanas
	int bOpt, b;
	QStrList bOptions;

	bOpt = cfg->boolOptions();
	for (b = 0; b < bOpt; b++) {
		if (cfg->boolValue(b + 1000))
			bOptions.append("true");
		else
			bOptions.append("false");
	}

	// Opcoes numericas
	int iOpt, a;
	QStrList iOptions;
	QString aux, aux2;

	iOpt = cfg->intOptions();
	for (a = 0; a < iOpt; a++) {
		aux.setNum( cfg->intValue(a + 1100) );
		iOptions.append(aux);
	}		

	if (profile_index > 0)
		aux2.setNum(profile_index);
	else
		aux2 = "";

	/* Salva as opcoes */

	config->setGroup("Command Line Options");
	config->writeEntry("Boolean_options"+aux2, bOptions);
	config->writeEntry("Integer_options"+aux2, iOptions);
	config->writeEntry("Custom_option"+aux2, cfg->strValue(ID_JOYSTICK_MISC) );

	/* Customize options */

	config->setGroup("General options");
	config->writeEntry("Filter", FILTER);
	config->writeEntry("Path", PATH);
	config->writeEntry("Snapshot filter", SNAP_FILTER);
	config->writeEntry("Snapshot path", SNAP_PATH);
	config->writeEntry("Snes9x command", SNES9X);
	config->writeEntry("Rect", geometry() );
	config->writeEntry("Quick snapshot", QUICK_SNAP);
	config->writeEntry("Quick profile", QUICK_PROF);

	/* Profiles */
	config->writeEntry("Profiles", profiles);
	config->writeEntry("Last profile", profile_index);



  config->sync();
	
}

/** Reseta a configuracao */
void KSnes9x::resetConfig(){
	int bOpt, iOpt, a;
	debug("Resetado!");
  bOpt = cfg->boolOptions();
	bOpt += 1000;
	iOpt = cfg->intOptions();
	iOpt += 1100;

	// Opcoes binarias (default)

	for (a = 1000; a < bOpt; a++) {
		cfg->setDefault( a );
	}

	// Opcoes numericas (default)

	for(a = 1100; a < iOpt; a++) {
		cfg->setDefault( a );
	}

	initMenuBarValues();
	
}

/** Pede o nome do arquivo */
void KSnes9x::loadSnapshot(const char *snap){
	if (snap == 0) {
		QString aux;
		aux = KFileDialog::getOpenFileName( SNAP_PATH, SNAP_FILTER, this );
		cfg->setValue( ID_ROM_LOADSNAPSHOT, aux );
	} else if ( strcmp(snap, "None") == 0 || strcmp(snap, "Select one") == 0 ) {
		cfg->setValue( ID_ROM_LOADSNAPSHOT, QString::QString("") );
	} else {
		QString aux(SNAP_PATH);
		aux += snap;
		cfg->setValue( ID_ROM_LOADSNAPSHOT, aux );
	}

	saveRomOptions( snap );
	
}

/** Chama a tela de configurao */
void KSnes9x::setup(){
	KSnes9xOptionsDialog m( this );
	if (m.exec()) {
		view->dirView->goToDir( PATH );	
		view->dirView->newFilter( FILTER );
		snapDir->setFilter( SNAP_FILTER );
		snapDir->setPath( SNAP_PATH );
		saveOptions();
		view->rebuildLayout();
	}
}

/** Arruma os valores das opes gerais */
void KSnes9x::setCustomValues(){

	const QRect defRect(0, 0, 440, 400);

	config->setGroup("General options");
	PATH = config->readEntry("Path", "");
	FILTER = config->readEntry("Filter", "*.zip ; *.smc");
	SNAP_FILTER = config->readEntry("Snapshot filter", "*.0??");
	SNAP_PATH = config->readEntry("Snapshot path", QDir::homeDirPath() + "/.snes96_snapshots");
	SNES9X = config->readEntry("Snes9x command", "snes9x");
	QUICK_PROF = config->readBoolEntry("Quick profile", true);
	QUICK_SNAP = config->readBoolEntry("Quick snapshot", true);
	setGeometry( config->readRectEntry("Rect", &defRect) );

	if (PATH == "") {
		KMsgBox::message( this, i18n("Attention"), i18n("Please enter the path where your roms are located"), 1 );
		setup();
	}
	else {
		view->dirView->goToDir( PATH );	
		view->dirView->newFilter( FILTER );
	}

	slotStatusDir(PATH);
	snapDir->setPath(SNAP_PATH);
	snapDir->setFilter(SNAP_FILTER);
	view->rebuildLayout();

}

/** Opo de cheat selecionada */
void KSnes9x::slotStrChecked(int id){
	inputString m( menuBar()->text(id), cfg->strValue(id), this);
	if (m.exec()) {
		cfg->setValue( id, m.getStr() );
	}
}

/** Inicializa o menu com todos os profiles */
void KSnes9x::initProfileMenu(){
	int a;

	config->setGroup("General Options");

	profile_menu = new QPopupMenu();
	profile_menu->insertItem(i18n("New profile.."), ID_PROFILE_NEW);
	profile_menu->insertItem(i18n("Remove current profile"), ID_PROFILE_REMOVE);
	profile_menu->setCheckable(true);
	profile_menu->insertSeparator();
	for (a = 0; a < (signed)profiles.count(); a++) {
		profile_menu->insertItem( profiles.at(a), ID_PROFILE_ITEM + a );
	}
	a = profile_index;
	profile_menu->setItemChecked( ID_PROFILE_ITEM + a, true );
	
	
}

/**  */
void KSnes9x::newProfile(){
	QString profile;
	inputString m( "New profile", "", this);
	if (m.exec()) {
		profile = m.getStr();
		profiles.append( profile );
		profile_index = profiles.count() - 1;
		reloadPopupMenu();
	}

}

/**  */
void KSnes9x::removeProfile(){
	// S remove se no for o ltimo
	if (profiles.count() <= 1) {
		KMsgBox::message(this, i18n("Attention!"), i18n("You can't remove your last profile!"), 1);
		return;
	}


	// Remove da lista
	profiles.remove( profile_index );

	int b;
	b = profiles.at();

	// Carrega o index+1, e joga-o no index
  unsigned int a;
	QString aux2;

	for (a = profile_index; a < profiles.count(); a++) {	
		// Carrega o config + 1
		setCfgValues( a + 1 );
		profile_index = a;
		saveOptions();
	}

	profile_index = profiles.count();

	// Apaga o ltimo valor
	if (profile_index > 0)
		aux2.setNum(profile_index);
	else
		aux2 = "";
	
	config->setGroup("Command Line Options");
	config->writeEntry("Boolean_options"+aux2, "");
	config->writeEntry("Integer_options"+aux2, "");
	config->writeEntry("Custom_option"+aux2, "" );

	// Carrega outro valor
	profile_index = b;
	setCfgValues( profile_index );

	// Atualiza tudo
	reloadPopupMenu();
	initMenuBarValues();


}

/**  */
void KSnes9x::loadProfile(int id){
	profile_index = id;
	setCfgValues(profile_index);
	reloadPopupMenu();
	initMenuBarValues();
}

/**  */
void KSnes9x::reloadPopupMenu(){
	unsigned int a;
	profile_menu->clear();
	profile_menu->insertItem(i18n("New profile.."), ID_PROFILE_NEW);
	profile_menu->insertItem(i18n("Remove current profile"), ID_PROFILE_REMOVE);
	profile_menu->setCheckable(true);
	profile_menu->insertSeparator();
	for (a = 0; a < profiles.count(); a++) {
		profile_menu->insertItem( profiles.at(a), ID_PROFILE_ITEM + a );
	}
	profile_menu->setItemChecked( ID_PROFILE_ITEM + profile_index, true );

	view->updateProfileMenu(profiles, profile_index);

}

/** Muda o diretorio */
void KSnes9x::slotStatusDir(const char * text){
///////////////////////////////////////////////////////////////////
// change status message permanently
	QString aux(text);

	aux += "     ";

  statusBar()->changeItem(aux, ID_STATUS_DIR );
}

void KSnes9x::initProfiles(){

	// Carrega a lista de profiles
	config->setGroup("General Options");
	if(!config->readListEntry("Profiles", profiles))
		profiles.append("Default");

	// Carrega o ltimo profile
	profile_index = config->readNumEntry("Last Profile", 0);	
	default_profile = 0;

	setCfgValues(profile_index);


}

bool KSnes9x::queryClose(){
	saveOptions();
	return true;
}

/** Atualiza o profile, snapshot do rom selecionado */
void KSnes9x::updateFileInfo(const char *filename){

	// Save the current Rom
	currentRom = filename;

	// Snapshots
	QString snap;
	if (QUICK_SNAP) {
		config->setGroup("Rom Snapshots");
		snap = config->readEntry( filename );
		snapDir->setDefaultSnap( snap );
		snapDir->setRomName( filename );
	}
	else {
		loadSnapshot("None");
	}

	// Profiles
 	QString prof;
	int index;
	if (QUICK_PROF) {
		config->setGroup("Rom Profiles");
		prof = config->readEntry( filename );
		if (prof == NULL)
			index = default_profile;
		else
			index = profiles.find( prof );
		loadProfile(index);
	}

}

