/***************************************************************************
                          ksnes9xconfig.cpp  -  description
                             -------------------
    begin                : Tue Oct 12 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksnes9xconfig.h"

KSnes9xConfig::KSnes9xConfig(){
	setDefaults();
}
KSnes9xConfig::~KSnes9xConfig(){
}

/** Arruma as opes default */
void KSnes9xConfig::setDefaults(){

/* Defaults Binarios */

// Defaults Graficos
	bV[ID_GRAPHICS_TRANSPARENCY - 1000].def = FALSE;
	bV[ID_GRAPHICS_SIXTEEN - 1000].def = FALSE;
	bV[ID_GRAPHICS_HIRES - 1000].def = FALSE;
	bV[ID_GRAPHICS_INTERPOLATE - 1000].def = FALSE;
	bV[ID_GRAPHICS_NOMODESWITCH - 1000].def = FALSE;
	bV[ID_GRAPHICS_FULLSCREEN - 1000].def = FALSE;
	bV[ID_GRAPHICS_SCALE - 1000].def = FALSE;
	bV[ID_GRAPHICS_DISPLAYFRAMERATE - 1000].def = FALSE;

// Defaults de Som
	bV[ID_SOUND_NOSOUND - 1000].def = FALSE;
	bV[ID_SOUND_STEREO - 1000].def = TRUE;
	bV[ID_SOUND_ENVX - 1000].def = FALSE;
	bV[ID_SOUND_THREADSOUND - 1000].def = FALSE;
	bV[ID_SOUND_SOUNDSYNC - 1000].def = FALSE;
	bV[ID_SOUND_INTERPOLATEDSOUND - 1000].def = FALSE;
	bV[ID_SOUND_NOSAMPLECACHING - 1000].def = FALSE;
	bV[ID_SOUND_NOECHO - 1000].def = FALSE;
	bV[ID_SOUND_NOMASTERVOLUME - 1000].def = FALSE;

// Defaults de Compatibilidade
	bV[ID_ROM_INTERLEAVED - 1000].def = FALSE;
	bV[ID_ROM_INTERLEAVED2 - 1000].def = FALSE;
	bV[ID_ROM_HIROM - 1000].def = FALSE;
	bV[ID_ROM_LOROM - 1000].def = FALSE;
	bV[ID_ROM_HEADER - 1000].def = FALSE;
	bV[ID_ROM_NOHEADER - 1000].def = FALSE;
	bV[ID_ROM_PAL - 1000].def = FALSE;
	bV[ID_ROM_NTSC - 1000].def = FALSE;
	bV[ID_ROM_LAYERING - 1000].def = FALSE;
	bV[ID_ROM_NOHDMA - 1000].def = FALSE;
	bV[ID_ROM_NOSPEEDHACKS - 1000].def = FALSE;
	bV[ID_ROM_NOWINDOWS - 1000].def = FALSE;

// Defaults de Joystick
	bV[ID_JOYSTICK_SWAP - 1000].def = FALSE;
	bV[ID_JOYSTICK_NOJOY - 1000].def = FALSE;
	bV[ID_JOYSTICK_OLD - 1000].def = FALSE;

/* Defaults Numericos */

// Sound Skip
	iV[ID_SPEED_SOUNDSKIP - 1100].def = -1;
	iV[ID_SPEED_SOUNDSKIP - 1100].range[0] = 0;
	iV[ID_SPEED_SOUNDSKIP - 1100].range[1] = 3;

// Sound Quality
	iV[ID_SOUND_SOUNDQUALITY - 1100].def = 4;
	iV[ID_SOUND_SOUNDQUALITY - 1100].range[0] = 0;
	iV[ID_SOUND_SOUNDQUALITY - 1100].range[1] = 7;

// Buffer Size
	iV[ID_SOUND_BUFFERSIZE - 1100].def = -1;
	iV[ID_SOUND_BUFFERSIZE - 1100].range[0] = 128;
	iV[ID_SOUND_BUFFERSIZE - 1100].range[1] = 4096;

// Frame Skip
	iV[ID_SPEED_FRAMESKIP - 1100].def = -1;
	iV[ID_SPEED_FRAMESKIP - 1100].range[0] = 0;
	iV[ID_SPEED_FRAMESKIP - 1100].range[1] = 9;

// Frame Time
	iV[ID_SPEED_FRAMETIME - 1100].def = -1;
	iV[ID_SPEED_FRAMETIME - 1100].range[0] = 0;
	iV[ID_SPEED_FRAMETIME - 1100].range[1] = 100;

// Cycles
	iV[ID_SPEED_CYCLES - 1100].def = 100;
	iV[ID_SPEED_CYCLES - 1100].range[0] = 0;
	iV[ID_SPEED_CYCLES - 1100].range[1] = 200;

/* Defaults de texto */

	sV[ID_CHEAT_GAMEGENIE - 1200] = "";
	sV[ID_CHEAT_ACTIONREPLAY - 1200] = "";
	sV[ID_CHEAT_GOLDFINGER - 1200] = "";
	sV[ID_ROM_LOADSNAPSHOT - 1200] = "";
	sV[ID_JOYSTICK_MISC - 1200] = "";

/* Arruma os comandos */

// Graficos
	boolCmdList[-1000 + ID_GRAPHICS_TRANSPARENCY] = "-transparency ";
	boolCmdList[-1000 + ID_GRAPHICS_SIXTEEN] = "-sixteen ";
	boolCmdList[-1000 + ID_GRAPHICS_HIRES] = "-hires ";
	boolCmdList[-1000 + ID_GRAPHICS_INTERPOLATE] = "-interpolate ";
	boolCmdList[-1000 + ID_GRAPHICS_NOMODESWITCH] = "-nomodeswitch ";
	boolCmdList[-1000 + ID_GRAPHICS_FULLSCREEN] = "-fullscreen ";
	boolCmdList[-1000 + ID_GRAPHICS_SCALE] = "-scale ";
	boolCmdList[-1000 + ID_GRAPHICS_DISPLAYFRAMERATE] = "-displayframerate ";

// Som
	boolCmdList[-1000 + ID_SOUND_NOSOUND] = "-nosound ";
	boolCmdList[-1000 + ID_SOUND_STEREO] = "-mono ";
	boolCmdList[-1000 + ID_SOUND_ENVX] = "-envx ";
	boolCmdList[-1000 + ID_SOUND_THREADSOUND] = "-threadsound ";
	boolCmdList[-1000 + ID_SOUND_SOUNDSYNC] = "-soundsync ";
	boolCmdList[-1000 + ID_SOUND_INTERPOLATEDSOUND] = "-interpolatedsound ";
	boolCmdList[-1000 + ID_SOUND_NOSAMPLECACHING] = "-nosamplecaching ";
	boolCmdList[-1000 + ID_SOUND_NOECHO] = "-noecho ";
	boolCmdList[-1000 + ID_SOUND_NOMASTERVOLUME] = "-nomastervolume ";

// Rom
	boolCmdList[-1000 + ID_ROM_INTERLEAVED] = "-interleaved ";
	boolCmdList[-1000 + ID_ROM_INTERLEAVED2] = "-i2 ";
	boolCmdList[-1000 + ID_ROM_HIROM] = "-hirom ";
	boolCmdList[-1000 + ID_ROM_LOROM] = "-lorom ";
	boolCmdList[-1000 + ID_ROM_NOHEADER] = "-noheader ";
	boolCmdList[-1000 + ID_ROM_HEADER] = "-header ";
	boolCmdList[-1000 + ID_ROM_PAL] = "-pal ";
	boolCmdList[-1000 + ID_ROM_NTSC] = "-ntsc ";
	boolCmdList[-1000 + ID_ROM_LAYERING] = "-layering ";
	boolCmdList[-1000 + ID_ROM_NOHDMA] = "-nohdma ";
	boolCmdList[-1000 + ID_ROM_NOSPEEDHACKS] = "-nospeedhacks ";
	boolCmdList[-1000 + ID_ROM_NOWINDOWS] = "-nowindows ";

// Joystick
	boolCmdList[-1000 + ID_JOYSTICK_SWAP] = "-swap ";
	boolCmdList[-1000 + ID_JOYSTICK_NOJOY] = "-nojoy ";
	boolCmdList[-1000 + ID_JOYSTICK_OLD] = "-old ";

/* Linhas de comandos numericos */
	intCmdList[-1100 + ID_SPEED_SOUNDSKIP] = "-soundskip ";
	intCmdList[-1100 + ID_SOUND_SOUNDQUALITY] = "-soundquality ";
	intCmdList[-1100 + ID_SOUND_BUFFERSIZE] = "-buffersize ";
	intCmdList[-1100 + ID_SPEED_FRAMESKIP] = "-frameskip ";
	intCmdList[-1100 + ID_SPEED_FRAMETIME] = "-frametime ";
	intCmdList[-1100 + ID_SPEED_CYCLES] = "-cycles ";

/* Linhas de comandos de texto */

	strCmdList[-1200 + ID_CHEAT_GAMEGENIE] = "-gamegenie ";
	strCmdList[-1200 + ID_CHEAT_ACTIONREPLAY] = "-actionreplay ";
	strCmdList[-1200 + ID_CHEAT_GOLDFINGER] = "-goldfinger ";
	strCmdList[-1200 + ID_ROM_LOADSNAPSHOT] = "-loadsnapshot ";
	strCmdList[-1200 + ID_JOYSTICK_MISC] = "";


}

/** Retorna o valor da opo numerica */
int KSnes9xConfig::intValue(int _id){
	return iV[_id - 1100].value;
}

/** Retorna o valor binario da opo correspondente */
bool KSnes9xConfig::boolValue(int _id){
	return bV[_id - 1000].value;
}

/** Seta a opcao */
void KSnes9xConfig::setValue(int _id, bool Value){
	bV[_id - 1000].value = Value;
}


/** Seta a opcao  */
void KSnes9xConfig::setValue(int _id, int Value){
	iV[_id - 1100].value = Value;
}

/** Retorna o valor minimo e maximo da opcao */
range KSnes9xConfig::getRange(int _id){
	range rg;
	rg.min = iV[_id - 1100].range[0];
	rg.max = iV[_id - 1100].range[1];
	return rg;
}

/** Seta para a opcao default */
void KSnes9xConfig::setDefault(int _id){
if (_id < 1100)
	bV[_id - 1000].value = bV[_id - 1000].def;
else if (_id >= 1100)
	iV[_id - 1100].value = iV[_id - 1100].def;
}


/** Retorna o nmero de opes binrias
 */
int KSnes9xConfig::boolOptions(){
	return BOOL_OPTIONS;
}

/** Retorna o nmero de opes numricas */
int KSnes9xConfig::intOptions(){
	return INT_OPTIONS;
}






/** Retorna a string com todas as opes */
QString KSnes9xConfig::optString(){
	QString aux, bux;;
	int a;

// BOOL Options
	for (a = 0; a < BOOL_OPTIONS; a++) {
		if (bV[a].value != bV[a].def)
			aux += boolCmdList[a];
	}

// INT Options
	for (a = 0; a < INT_OPTIONS; a++) {
		if (iV[a].value != iV[a].def) {
			aux += intCmdList[a];
			bux.setNum(iV[a].value);
			aux += bux;
			aux += " ";
		}
	}

// STR Options
	for (a = 0; a < STR_OPTIONS; a++) {
		if (sV[a] != "") {
			aux += strCmdList[a];
			aux += sV[a];
			aux += " ";
		}
	}
	
	return aux;
}
/**  */
void KSnes9xConfig::setValue(int _id, QString Value){
	sV[_id - 1200] = Value;
}

/** Retorna o nmero de opes de texto */
int KSnes9xConfig::strOptions(){
	return STR_OPTIONS;
}


/** Retorna a string correspondente a id */
QString KSnes9xConfig::strValue(int _id){
	return sV[_id - 1200];
}





/**  */
QString KSnes9xConfig::statusString(int _id){
	QString aux,aux2;
	aux = "";
	if (1100 <= _id && 1200 > _id) {
		// Numeric value
		aux = "  [ ";
		if ( iV[_id - 1100].value <= 0 ) {
			// Default value
			aux += "default";
		} else {
			aux2.setNum( iV[_id - 1100].value );
			aux += aux2;
		}
		aux += " ]";
	}
	else if (1200 <= _id && 1300 > _id && sV[_id - 1200] != "") {
		// String value
		aux = "  [ ";
		aux += sV[_id - 1200];
		aux += " ]";
	}
	return aux;
}
