/***************************************************************************
                          ksnes9xfiledialog.cpp  -  description
                             -------------------
    begin                : Sun Oct 10 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksnes9xfiledialog.h"

KSnes9xFileDialog::KSnes9xFileDialog(bool singleClick, const char *dirName, const char *filter, QWidget *parent, const char *name)
 : KFileSimpleView(singleClick, QDir::Name, parent, name)
{
	dlgPath = (char *)dirName;
	dirEntry = new KDir( dlgPath, filter, QDir::Name );
	reload();
	connectFileHighlighted( this, SLOT(choosenFile(KFileInfo *) ) );
	connectFileSelected( this, SLOT(fileDoubleClicked(KFileInfo *) ) );
	connectDirSelected( this, SLOT(dirActivated(KFileInfo *) ) );
	connect( dirEntry, SIGNAL(finished()), this, SLOT(reload()) );
	highlight( 0 );
}

KSnes9xFileDialog::~KSnes9xFileDialog()
{
}

/** Retorna o arquivo selecionado */
QString KSnes9xFileDialog::fileName(){
	QString aux;
	aux.setStr( dlgPath );
	if (aux.right(1) != "/")
		aux += '/';
	aux += highFile->fileName();
	return aux;
}

/** Slot representando o arquivo selecionando */
void KSnes9xFileDialog::choosenFile(KFileInfo *file){
	highFile = file;
	if (!file->isDir())
		emit fileClicked(file->fileName());
}

/** Muda para o diretorio selecionado */
void KSnes9xFileDialog::dirActivated(KFileInfo *dir){
	QString aux;
	aux.setStr( dlgPath );
	if (aux.right(1) != "/")
		aux += '/';
	aux += dir->fileName();
	dirEntry->setPath( aux );
	dlgPath = (char *)dirEntry->path();
	emit dirChanged(dirEntry->path());
	reload();
}

void KSnes9xFileDialog::fileDoubleClicked( KFileInfo *file ) {
	choosenFile( file );
	emit goPlay();
}


/** Recarrega a listagem do diretorio */
void KSnes9xFileDialog::reload(){
	disconnect( dirEntry, SIGNAL(finished()), this, SLOT(reload()) );
	clear();
	addItemList( dirEntry->entryInfoList( QDir::Files | QDir::Dirs, QDir::Name ) );
	highlight(0);
	connect( dirEntry, SIGNAL(finished()), this, SLOT(reload()) );
}

void KSnes9xFileDialog::goToDir(QString dir){
	dirEntry->setPath( dir );
	dlgPath = (char *)dirEntry->path();
	emit dirChanged(dirEntry->path());
	reload();
}

void KSnes9xFileDialog::newFilter(QString filter){
	dirEntry->setNameFilter( filter );
	reload();
}

/** Arquivo selecionado? */
bool KSnes9xFileDialog::ok(){
	return !highFile->isDir();
}
