/***************************************************************************
                          ksnes9xfiledialog.h  -  description
                             -------------------
    begin                : Sun Oct 10 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSNES9XFILEDIALOG_H
#define KSNES9XFILEDIALOG_H

#include <kfilesimpleview.h>
#include <kfileinfo.h>
#include <kapp.h>
#include <qwidget.h>
#include <kdir.h>
#include <qstring.h>

/**Reimplementao do KFileBaseDialog para atender s necessidades do KSnes9x
  *@author Perdig
  */

class KSnes9xFileDialog : public KFileSimpleView  {
	Q_OBJECT
public:
    KSnes9xFileDialog(bool singleClick, const char *dirName, const char *filter=0, QWidget *parent=0, const char *name=0);
		~KSnes9xFileDialog();
  /** Retorna o arquivo selecionado */
  QString fileName();
  void goToDir(QString dir);
	void newFilter(QString filter);
  /** Arquivo selecionado? */
  bool ok();

public slots:
	void fileDoubleClicked(KFileInfo *file);
protected:
		KDir *dirEntry;
		KFileInfo *highFile;
		char *dlgPath;
private slots: // Private slots
  /** Slot representando o arquivo selecionando */
  void choosenFile(KFileInfo *file);
	void dirActivated(KFileInfo *dir);
  /** Recarrega a listagem do diretorio */
  void reload();
signals: // Signals
  void dirChanged(const char *dir);
	void fileClicked(const char *filename);
  void goPlay();
};

#endif













































