/***************************************************************************
                          ksnes9xmenu.cpp  -  description
                             -------------------
    begin                : Wed Dec 22 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ksnes9x.h"

extern QString PATH;
extern QString FILTER;
extern QString SNAP_FILTER;
extern QString SNAP_PATH;
extern QString SNES9X;

#define DIR_LEN 40


void KSnes9x::enableCommand(int id_)
{
  ///////////////////////////////////////////////////////////////////
  // enable menu and toolbar functions by their ID's
  menuBar()->setItemEnabled(id_,true);
}

void KSnes9x::disableCommand(int id_)
{
  ///////////////////////////////////////////////////////////////////
  // disable menu and toolbar functions by their ID's
  menuBar()->setItemEnabled(id_,false);
}


void KSnes9x::initMenuBar()
{

  // MENUBAR

  // menuBar entry file_menu
  file_menu = new QPopupMenu();
  file_menu->insertItem(i18n("&Play"), ID_FILE_PLAY);
	file_menu->insertSeparator();
	file_menu->insertItem(i18n("Profiles"), profile_menu, ID_FILE_PROFILE);
	file_menu->insertItem(i18n("Reset"), ID_FILE_RESET);
	file_menu->insertItem(i18n("Setup"), ID_FILE_SETUP);
	file_menu->insertSeparator();
	file_menu->insertItem(i18n("E&xit"), ID_FILE_EXIT);

	// menuBar entry graphics_menu
	graphics_menu = new QPopupMenu();
	graphics_menu->setCheckable(true);
	graphics_menu->insertItem(i18n("&Transparency"), ID_GRAPHICS_TRANSPARENCY);
	graphics_menu->insertItem(i18n("16-&bit rendering"), ID_GRAPHICS_SIXTEEN);
	graphics_menu->insertItem(i18n("&Hi-Res"), ID_GRAPHICS_HIRES);
	graphics_menu->insertItem(i18n("&Interpolate"), ID_GRAPHICS_INTERPOLATE);
	graphics_menu->insertItem(i18n("&No mode switch"), ID_GRAPHICS_NOMODESWITCH);
	graphics_menu->insertItem(i18n("&Full screen"), ID_GRAPHICS_FULLSCREEN);
	graphics_menu->insertItem(i18n("&Scale"), ID_GRAPHICS_SCALE);
	graphics_menu->insertItem(i18n("&Display frame rate"), ID_GRAPHICS_DISPLAYFRAMERATE);

	// menuBar entry sound_menu
	sound_menu = new QPopupMenu();
	sound_menu->setCheckable(true);
	sound_menu->insertItem(i18n("No s&ound"), ID_SOUND_NOSOUND);
	sound_menu->insertItem(i18n("S&tereo"), ID_SOUND_STEREO);
	sound_menu->insertItem(i18n("Sound &quality..."), ID_SOUND_SOUNDQUALITY);
	sound_menu->insertItem(i18n("&Volume envelope height"), ID_SOUND_ENVX);
	sound_menu->insertItem(i18n("Threaded sound"), ID_SOUND_THREADSOUND);
	sound_menu->insertItem(i18n("Sound sync"), ID_SOUND_SOUNDSYNC);
	sound_menu->insertItem(i18n("Interpolated sound"), ID_SOUND_INTERPOLATEDSOUND);
	sound_menu->insertItem(i18n("Buffer size..."), ID_SOUND_BUFFERSIZE);
	sound_menu->insertItem(i18n("Sound sample caching"), ID_SOUND_NOSAMPLECACHING);
	sound_menu->insertItem(i18n("Echo"), ID_SOUND_NOECHO);
	sound_menu->insertItem(i18n("Master volume control"), ID_SOUND_NOMASTERVOLUME);

	// menuBar entry cheat_menu
	cheat_menu = new QPopupMenu();
	cheat_menu->insertItem(i18n("Game genie code..."), ID_CHEAT_GAMEGENIE);
	cheat_menu->insertItem(i18n("Action replay code..."), ID_CHEAT_ACTIONREPLAY);
	cheat_menu->insertItem(i18n("Gold finger code..."), ID_CHEAT_GOLDFINGER);

	// menuBar entry speed_menu
	speed_menu = new QPopupMenu();
	speed_menu->insertItem(i18n("Sound s&kip..."), ID_SPEED_SOUNDSKIP);
	speed_menu->insertItem(i18n("Frameskip..."), ID_SPEED_FRAMESKIP);
	speed_menu->insertItem(i18n("Frametime..."), ID_SPEED_FRAMETIME);
	speed_menu->insertItem(i18n("Cycles..."), ID_SPEED_CYCLES);

	// menuBar entry rom_menu
	rom_menu = new QPopupMenu();
	rom_menu->setCheckable(true);
	rom_menu->insertItem(i18n("Interleaved rom"), ID_ROM_INTERLEAVED);
	rom_menu->insertItem(i18n("Interleaved 2 rom"), ID_ROM_INTERLEAVED2);
	rom_menu->insertItem(i18n("Hi-Rom"), ID_ROM_HIROM);
	rom_menu->insertItem(i18n("Lo-Rom"), ID_ROM_LOROM);
	rom_menu->insertItem(i18n("Header"), ID_ROM_HEADER);
	rom_menu->insertItem(i18n("No Header"), ID_ROM_NOHEADER);
	rom_menu->insertItem(i18n("Pal-M"), ID_ROM_PAL);
	rom_menu->insertItem(i18n("Ntsc"), ID_ROM_NTSC);
	rom_menu->insertItem(i18n("Layering"), ID_ROM_LAYERING);
	rom_menu->insertItem(i18n("Load snapshot..."), ID_ROM_LOADSNAPSHOT);
	rom_menu->insertItem(i18n("No H-DMA"), ID_ROM_NOHDMA);
	rom_menu->insertItem(i18n("No Speedhacks"), ID_ROM_NOSPEEDHACKS);
	rom_menu->insertItem(i18n("No Graphics Windows"), ID_ROM_NOWINDOWS);

	// menuBar entry joystick_menu
	joystick_menu = new QPopupMenu();
	joystick_menu->setCheckable(true);
	joystick_menu->insertItem(i18n("Joystick configuration..."), ID_JOYSTICK_JOYCONF);
	joystick_menu->insertItem(i18n("Swap Joystick"), ID_JOYSTICK_SWAP);
	joystick_menu->insertItem(i18n("No Joystick"), ID_JOYSTICK_NOJOY);
	joystick_menu->insertItem(i18n("Old style"), ID_JOYSTICK_OLD);
	joystick_menu->insertSeparator();
	joystick_menu->insertItem(i18n("Custom command"), ID_JOYSTICK_MISC);


  ///////////////////////////////////////////////////////////////////
  // menuBar entry help_menu
  QString aboutstring= kapp->appName()+" "+VERSION+"\n\n"+"Ismael Orenstein\n" + "perdig@linuxbr.com.br\n"+"http://www.esquadro.com.br/~ismore\n\n";

  help_menu = new QPopupMenu();
  help_menu = kapp->getHelpMenu(true, aboutstring );

  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
  // insert your popup menus with the according menubar entries in the order
  // they will appear later from left to right
  menuBar()->insertItem(i18n("&File"), file_menu);
  menuBar()->insertItem(i18n("&Graphics"), graphics_menu);
  menuBar()->insertItem(i18n("&Sound"), sound_menu);
	menuBar()->insertItem(i18n("&Cheat"), cheat_menu);
	menuBar()->insertItem(i18n("S&peed"), speed_menu);
	menuBar()->insertItem(i18n("&Rom"), rom_menu);
	menuBar()->insertItem(i18n("&Joystick"), joystick_menu);

  menuBar()->insertSeparator();
  menuBar()->insertItem(i18n("&Help"), help_menu);

  ///////////////////////////////////////////////////////////////////
  // CONNECT THE MENU SLOTS WITH SIGNALS
  // for execution slots and statusbar messages

  connect(file_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
  connect(file_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

  connect(graphics_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
  connect(graphics_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

  connect(sound_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
  connect(sound_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));
	
	connect(cheat_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
	connect(cheat_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

	connect(speed_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
	connect(speed_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

	connect(rom_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
	connect(rom_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

	connect(joystick_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
	connect(joystick_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));

	connect(profile_menu,SIGNAL(activated(int)),SLOT(commandCallback(int)));
	connect(profile_menu,SIGNAL(highlighted(int)),SLOT(statusCallback(int)));
}

void KSnes9x::initKeyAccel()
{
	key_accel = new KAccel( this );
	
	key_accel->connectItem( KAccel::Help, kapp, SLOT( appHelpActivated() ) );
	
	key_accel->changeMenuAccel(	file_menu, ID_FILE_EXIT, KAccel::Quit );

  key_accel->readSettings();	
}

void KSnes9x::commandCallback(int id_){
	if ( id_ < 1100 )
			slotBoolChecked( id_ );
	else if ( id_ >= 1100 && id_ < 1200)
			slotIntChecked( id_ );
	else if ( id_ >= 1200 && id_ < ID_ROM_LOADSNAPSHOT)
			slotStrChecked( id_ );
	else if (id_ == ID_FILE_PLAY)
			goForIt();
	else if (id_ == ID_FILE_RESET)
			resetConfig();	
	else if (id_ == ID_ROM_LOADSNAPSHOT)
			loadSnapshot();
	else if (id_ == ID_FILE_SETUP)
			setup();
	else if (id_ == ID_FILE_EXIT) {
			saveOptions();
//			kapp->quit();
			close();
			return;
	}
	else if (id_ == ID_PROFILE_NEW)
			newProfile();
	else if (id_ == ID_PROFILE_REMOVE)
			removeProfile();
	else if (unsigned(id_) >= ID_PROFILE_ITEM && unsigned(id_) < (ID_PROFILE_ITEM + profiles.count()) ) {
			loadProfile(id_ - ID_PROFILE_ITEM);			
			saveRomOptions( NULL, profiles.at(id_ - ID_PROFILE_ITEM) );
	}
	saveOptions();
}

/** Mostra uma messagem */
void KSnes9x::slotStatusMsg(const char *text){
  ///////////////////////////////////////////////////////////////////
  // change status message permanently
  statusBar()->clear();
  statusBar()->changeItem(text, ID_STATUS_MSG );
}

/** Inicializa a barra de status */
void KSnes9x::initStatusBar(){
  ///////////////////////////////////////////////////////////////////
  // STATUSBAR
	// TODO: add your own items you need for displaying current application status.

	QString aux;

//	statusBar()->setInsertOrder( KStatusBar::RightToLeft );

	statusBar()->insertItem( i18n("Ready.   "), ID_STATUS_MSG );

	aux.fill(' ', DIR_LEN);
	statusBar()->insertItem( aux, ID_STATUS_DIR );
	statusBar()->setAlignment( ID_STATUS_DIR, AlignRight );

}

/** Mostra o texto de status correspondente */
void KSnes9x::statusCallback(int id_){
  switch (id_){
// File options
    case ID_FILE_EXIT:{
    	QString caption=kapp->getCaption();
    	slotStatusHelpMsg(i18n("Exits "+ caption));
    	break;
		}
		case ID_FILE_SETUP:
			slotStatusHelpMsg(i18n("Configures ksnes9x"));
			break;
		case ID_FILE_PLAY:
			slotStatusHelpMsg(i18n("Run the emulator"));
			break;
		case ID_FILE_RESET:
			slotStatusHelpMsg(i18n("Reset the configuration values"));
			break;
// Graphic options
		case ID_GRAPHICS_TRANSPARENCY:
			slotStatusHelpMsg(i18n("Enable transparency effecs"));
			break;
		case ID_GRAPHICS_SIXTEEN:
			slotStatusHelpMsg(i18n("Enable 16-bit screen rendering"));
			break;
		case ID_GRAPHICS_HIRES:
			slotStatusHelpMsg(i18n("Enable support for SNES Hi-Resolution and interlace modes"));
			break;
		case ID_GRAPHICS_INTERPOLATE:
			slotStatusHelpMsg(i18n("Enables TV-mode, which scales the image by x2"));
			break;
		case ID_GRAPHICS_NOMODESWITCH:
			slotStatusHelpMsg(i18n("Disable the screen resolution switch"));
			break;
		case ID_GRAPHICS_FULLSCREEN:
			slotStatusHelpMsg(i18n("Enables full screen"));
			break;
		case ID_GRAPHICS_SCALE:
			slotStatusHelpMsg(i18n("Stretch the SNES display to fit the whole display"));
			break;
		case ID_GRAPHICS_DISPLAYFRAMERATE:
			slotStatusHelpMsg(i18n("Display a frame rate counter"));
			break;
// Sound options
		case ID_SOUND_NOSOUND:
			slotStatusHelpMsg(i18n("Disable sound CPU emulation and sound output"));
			break;
		case ID_SPEED_SOUNDSKIP:
			slotStatusHelpMsg(i18n("Fool a ROM into thinking there is sound emulation ") + cfg->statusString(id_) );
			break;
		case ID_SOUND_STEREO:
			slotStatusHelpMsg(i18n("Enable Stereo sound output"));
			break;
		case ID_SOUND_SOUNDQUALITY:
			slotStatusHelpMsg(i18n("Sound playback rate/quality (0-off 7-better) ") + cfg->statusString(id_) );
			break;
		case ID_SOUND_ENVX:
			slotStatusHelpMsg(i18n("Enable volume envelope height reading (Used to correct problems)"));
			break;
		case ID_SOUND_THREADSOUND:
			slotStatusHelpMsg(i18n("Feed data to the sound card using a separate thread"));
			break;
		case ID_SOUND_SOUNDSYNC:
			slotStatusHelpMsg(i18n("Turns on sound syncronization"));
			break;
		case ID_SOUND_INTERPOLATEDSOUND:
			slotStatusHelpMsg(i18n("Turns on interpolated sound"));
			break;
		case ID_SOUND_BUFFERSIZE:
			slotStatusHelpMsg(i18n("Sound playback buffer size in bytes ") + cfg->statusString(id_) );
			break;
		case ID_SOUND_NOSAMPLECACHING:
			slotStatusHelpMsg(i18n("Disable decompressed sound sample caching"));
			break;
		case ID_SOUND_NOECHO:
			slotStatusHelpMsg(i18n("Turn off sound echo and FIR filter effects"));
			break;
		case ID_SOUND_NOMASTERVOLUME:
			slotStatusHelpMsg(i18n("Disable emulation of the sound DSP master volume control"));
			break;
// Cheat options
		case ID_CHEAT_GAMEGENIE:
			slotStatusHelpMsg(i18n("Supply a Game Genie code") + cfg->statusString(id_) );
			break;
		case ID_CHEAT_ACTIONREPLAY:
			slotStatusHelpMsg(i18n("Supply a Pro-Action Replay code") + cfg->statusString(id_) );
			break;
		case ID_CHEAT_GOLDFINGER:
			slotStatusHelpMsg(i18n("Supply a Gold Finger code") + cfg->statusString(id_) );
			break;
// Speed options
    case ID_SPEED_FRAMESKIP:
			slotStatusHelpMsg(i18n("Set this value to deliberately fix the frame skip rate and siable auto-speed regulation") + cfg->statusString(id_) );
			break;
		case ID_SPEED_FRAMETIME:
			slotStatusHelpMsg(i18n("If auto-adjust frame skip is enabled, each frame will long up to this value") + cfg->statusString(id_) );
			break;
		case ID_SPEED_CYCLES:
			slotStatusHelpMsg(i18n("Percentage of CPU cycles to execute per scan line") + cfg->statusString(id_) );
			break;
// ROM options
		case ID_ROM_INTERLEAVED:
			slotStatusHelpMsg(i18n("Force interleaved ROM image format"));
			break;
		case ID_ROM_INTERLEAVED2:
			slotStatusHelpMsg(i18n("Force alternate interleaved format"));
			break;
		case ID_ROM_HIROM:
			slotStatusHelpMsg(i18n("Force Hi-ROM memory map"));
			break;
		case ID_ROM_LOROM:
			slotStatusHelpMsg(i18n("Force Lo-ROM memory map"));
			break;
		case ID_ROM_HEADER:
			slotStatusHelpMsg(i18n("Force the detection of a ROM image header"));
			break;
		case ID_ROM_NOHEADER:
			slotStatusHelpMsg(i18n("Force Snes9x into thinking no ROM image header is present"));
			break;
		case ID_ROM_PAL:
			slotStatusHelpMsg(i18n("Fool ROM into thinking this is a PAL SNES"));
			break;
		case ID_ROM_NTSC:
			slotStatusHelpMsg(i18n("Fool ROM into thinking this is a NTSC SNES"));
			break;
		case ID_ROM_LAYERING:
			slotStatusHelpMsg(i18n("Swap background layer priorities"));
			break;
		case ID_ROM_NOHDMA:
			slotStatusHelpMsg(i18n("Turn off the H-DMA emulation"));
			break;
		case ID_ROM_NOSPEEDHACKS:
			slotStatusHelpMsg(i18n("Turn off a couple of speed hacks"));
			break;
		case ID_ROM_NOWINDOWS:
			slotStatusHelpMsg(i18n("Disable graphics windows emulation"));
			break;
		case ID_ROM_LOADSNAPSHOT:
			slotStatusHelpMsg(i18n("Load a previous saved snapshot") + cfg->statusString(id_) );
			break;
// Joystick options
		case ID_JOYSTICK_JOYCONF:
			slotStatusHelpMsg(i18n("Configures the joystick"));
			break;
		case ID_JOYSTICK_SWAP:
			slotStatusHelpMsg(i18n("Swap emulated joy-pad 1 and 2 around"));
			break;
		case ID_JOYSTICK_NOJOY:
			slotStatusHelpMsg(i18n("Disable joystick configuration"));
			break;
		case ID_JOYSTICK_OLD:
			slotStatusHelpMsg(i18n("Enable old-style SNES joypad emulation"));
			break;
		case ID_JOYSTICK_MISC:
			slotStatusHelpMsg(i18n("Enter a miscellaneous command") + cfg->statusString(id_) );
			break;
		default:
			break;
  }
}

/** Temporary status bar text */
void KSnes9x::slotStatusHelpMsg(const char *text){
  ///////////////////////////////////////////////////////////////////
  // change status message of whole statusbar temporary (text, msec)
  statusBar()->message(text, 2000);
}
                                                                                                      //Del by KDevelop:                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         //Del by KDevelop:                                                                                                                                                                                                                                                                                    //Del by KDevelop:                                                                                                                                                                                                                                                                                       //Del by KDevelop: /**  */
void KSnes9x::saveRomOptions(const char *snapshot, const char *profile){
	if (snapshot != NULL) {
		config->setGroup("Rom Snapshots");
		config->writeEntry( (const char *)currentRom, snapshot );
	}

	if (profile != NULL) {
		config->setGroup("Rom Profiles");
		config->writeEntry( (const char *)currentRom, profile );
	}
}
