/***************************************************************************
                          ksnes9xoptionsdialog.h  -  description
                             -------------------
    begin                : Sun Oct 24 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSNES9XOPTIONSDIALOG_H
#define KSNES9XOPTIONSDIALOG_H

#include <qtabdialog.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qframe.h>
#include <qpushbutton.h>
#include <klined.h>
#include <qlabel.h>
#include <kiconloader.h>
#include <kfiledialog.h>
#include <kapp.h>
#include <kseparator.h>

/**Dialogo de opes
  *@author Perdig
  */

class KSnes9xOptionsDialog : public QTabDialog  {
	Q_OBJECT
public: 
	KSnes9xOptionsDialog(QWidget *parent = 0, const char *name = 0);
	~KSnes9xOptionsDialog();
protected:

// Widgets
	QWidget *main_page;
	QWidget *quick_page;

// Snes9x box
	QGroupBox *snes9x_box;
	QLabel *snes9x_label;
	KLined *snes9x_path;
	QPushButton *snes9x_browse;

// ROM box
	QGroupBox *rom_box;
	QLabel *rom_label_path;
	QLabel *rom_label_filter;
	KLined *rom_path;
	KLined *rom_filter;
	QPushButton *rom_path_browse;

// Snap box
	QGroupBox *snap_box;
	QLabel *snap_label_path;
	QLabel *snap_label_filter;
	KLined *snap_path;
	KLined *snap_filter;
	QPushButton *snap_path_browse;

// Button box
	QPushButton *help;

// Quick loading
	QGroupBox *quick_box;
	QLabel *quick_label_snap;
	QLabel *quick_label_prof;
	QButtonGroup *quick_group_snap;
	QButtonGroup *quick_group_prof;
	QRadioButton *quick_button_snap_on;
	QRadioButton *quick_button_snap_off;
	QRadioButton *quick_button_prof_on;
	QRadioButton *quick_button_prof_off;

protected slots:

	void snes9x_click() { snes9x_path->setText( KFileDialog::getOpenFileName(snes9x_path->text(), 0, this) ); };
	void rom_path_click() { rom_path->setText( KDirDialog::getDirectory(rom_path->text(), this) ); };
	void snap_path_click() { snap_path->setText( KDirDialog::getDirectory(snap_path->text(), this) ); };

private slots: // Private slots
  /** Call for help */
  void helpPressed();
  /** Save options and return to the program */
  void okPressed();
};

#endif








