/***************************************************************************
                          ksnes9xview.cpp  -  description
                             -------------------
    begin                : Sun Oct 10 1999
    copyright            : (C) 1999 by Perdig
    email                : perdig@linuxbr.com.br
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "ksnes9xview.h"
#include <qlabel.h>

extern QString PATH;
extern QString FILTER;
extern bool QUICK_SNAP;
extern bool QUICK_PROF;

KSnes9xView::KSnes9xView(QWidget *parent, const char *name) : QWidget(parent,name){
	initDialog();
	initKDir();
}

KSnes9xView::~KSnes9xView(){
}



/** Inicializa o Kdir */
void KSnes9xView::initKDir(){
	dirView= new KSnes9xFileDialog( true, PATH, FILTER, this);
	boxLayout = new QHBoxLayout( this, 5 );
	boxLayout->addWidget( dirView->widget(), 15);
	btngroup = new QVBoxLayout();
	boxLayout->addLayout( btngroup, 0 );
	btngroup->addWidget( play, 1, AlignTop);
	btngroup->addStretch( 2 );
	btngroup->addWidget( QLabel_1, 1, AlignTop);
	btngroup->addWidget( profile_list, 1, AlignTop);
	btngroup->addStretch( 1 );
	btngroup->addWidget( QLabel_3, 1, AlignTop);
	btngroup->addWidget( snapshot_list, 1, AlignTop);
	btngroup->addStretch( 8 );
	boxLayout->activate();
}

/**  */
void KSnes9xView::updateSnapMenu( QStrList *list, int index){
	unsigned int a;

	snapshot_list->clear();
	if (list->count() == 0)
	  snapshot_list->insertItem(i18n("None"));
	else
	  snapshot_list->insertItem(i18n("Select one"));
	for (a = 0; a < list->count(); a++) {
		snapshot_list->insertItem( list->at(a) );
	}	

	snapshot_list->setCurrentItem( index );
}

/**  */
void KSnes9xView::updateProfileMenu(QStrList profiles, unsigned int index){
	profile_list->clear();
	while (profiles.current() != NULL) {
		profile_list->insertItem(profiles.current());
		profiles.next();
	}
	profile_list->setCurrentItem( index );
}

/** Reload the layout, removing or inserting the Quick Snapshot/Profiles */
void KSnes9xView::rebuildLayout(){
	if (QUICK_PROF) {
		profile_list->show();
		QLabel_1->show();
	}		
	else {
		profile_list->hide();
		QLabel_1->hide();
	}

	if (QUICK_SNAP) {
		snapshot_list->show();	
		QLabel_3->show();
	}
	else {
		snapshot_list->hide();
		QLabel_3->hide();
	}
}















































